// Y2B.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <fcntl.h>
#include <io.h>
#include <stdlib.h>
#include <stdio.h>
#include <windows.h>

#define BYTE unsigned char
#define BOOL bool
#define DWORD unsigned long
#define FALSE 0
#define TRUE 1

BYTE *pYUVBuf, *pRGBBuf;


//#define YUV_SIZE 84480L+21120+21120
//#define RGB_SIZE IMAGE_WIDTH*IMAGE_HEIGHT*3L
//#define YUVFilename "c:\\pict.yuv"
//#define BMPFilename "c:\\pict.bmp"

/*

#define YUV_SIZE 1536L
#define IMAGE_WIDTH	32L
#define IMAGE_HEIGHT 32L

#define RGB_SIZE IMAGE_WIDTH*IMAGE_HEIGHT*3L
#define YUVFilename "gta10.bin"
#define BMPFilename "pp0.bmp"
*/

long U[256], V[256], Y1[256], Y2[256];

DWORD IMAGE_WIDTH=1;
DWORD IMAGE_HEIGHT=1;
DWORD YUV_SIZE=0;
DWORD RGB_SIZE=0;

char YUVFilename[MAX_PATH];
char BMPFilename[MAX_PATH];

void MakeConversionTable()
{
	long i;

	for (i=0; i<256; i++)
	{

		V[i] = 15938*i-2221300;
        U[i] = 20238*i-2771300;
        Y1[i] = 11644*i;
        Y2[i] = 19837*i-311710;

	}

}

BOOL YUV420ToRGB (DWORD width, 
			  DWORD height,
			  BYTE *pYUVBuf,
			  BYTE *pRGBBuf
			  )
{
	unsigned char *pY, *pU, *pV, *pUbase, *pVbase;
	DWORD i, j;
	unsigned char *pR, *pG, *pB;
	

 
	
	pY = pYUVBuf;
	pU = pUbase = pYUVBuf + width*height;
	pV = pVbase = pUbase + width*height/4;

	for (i=0; i<height; i++)
	{
		pB = pRGBBuf+RGB_SIZE-3*width*(i+1);
		pG = pRGBBuf+RGB_SIZE-3*width*(i+1)+1;
		pR = pRGBBuf+RGB_SIZE-3*width*(i+1)+2;

		for (j=0; j<width; j+=2)
		{
			
			*pR = max (0, min (255, (V[*pV] + Y1[*pY])/10000) );   //R value
			*pB = max (0, min (255, (U[*pU] + Y1[*pY])/10000) );   //B value
			*pG = max (0, min (255, (Y2[*pY] - 5094*(*pR) - 1942*(*pB))/10000) ); //G value

			pR += 3;
			pB += 3;
			pG += 3;
			pY++;
						
			*pR = max (0, min (255, (V[*pV] + Y1[*pY])/10000) );   //R value
			*pB = max (0, min (255, (U[*pU] + Y1[*pY])/10000) );   //B value
			*pG = max (0, min (255, (Y2[*pY] - 5094*(*pR) - 1942*(*pB))/10000) ); //G value
			
			pR += 3;
			pB += 3;
			pG += 3;
			pY++;

			pU++;
			pV++;
		}
		if ((i % 2 == 0))
		{
			pU = pU-(width >> 1);
			pV = pV-(width >> 1);
		}

	}

	return TRUE;
}



BOOL AllocateBuffers()
{
	pYUVBuf = (BYTE *)new char [YUV_SIZE];
	pRGBBuf = (BYTE *)new char [RGB_SIZE];

	if (pYUVBuf && pRGBBuf)
		return TRUE;
	else
		return FALSE;

}

void FreeBuffers()
{
	if (pYUVBuf) delete pYUVBuf; 
	if (pRGBBuf) delete pRGBBuf;
	pYUVBuf = pRGBBuf = NULL;
}

BOOL ReadYUVFile()
{
	int fp;
	DWORD count=0;

	if( (fp = _open( YUVFilename, _O_RDONLY|_O_BINARY )) == -1 ) 
	{
		printf( "ERR001 ޷ YUV ļ: %s\n", YUVFilename );
		return FALSE;
	}
 

	if ((count=_read(fp, pYUVBuf, YUV_SIZE)) != YUV_SIZE)
	{
		printf( "ERR002 ȡ YUV ļʧ: =%d\n", count);
		_close(fp);
		return FALSE;
	}
 

	_close(fp);
	return TRUE;
}

BOOL WriteBMPFile()
{
	FILE *fp;
	DWORD count=0;
	BITMAPFILEHEADER bmpHeader;
	BITMAPINFO bmpInfo;

	if( (fp = fopen( BMPFilename, "wb")) == NULL ) 
	{
		printf( "ERR003 ޷ BMPļ: %s\n", YUVFilename );
		return FALSE;
	}
 

	bmpHeader.bfType = 'MB';
	bmpHeader.bfSize = RGB_SIZE + sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
	bmpHeader.bfReserved1 = 0;
	bmpHeader.bfReserved2 = 0;
	bmpHeader.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
	bmpInfo.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	bmpInfo.bmiHeader.biWidth = IMAGE_WIDTH;
	bmpInfo.bmiHeader.biHeight = IMAGE_HEIGHT;
	bmpInfo.bmiHeader.biPlanes = 1;
	bmpInfo.bmiHeader.biBitCount = 24;
	bmpInfo.bmiHeader.biCompression = BI_RGB;
	bmpInfo.bmiHeader.biSizeImage = RGB_SIZE;
	bmpInfo.bmiHeader.biXPelsPerMeter = 0;
	bmpInfo.bmiHeader.biYPelsPerMeter = 0;
	bmpInfo.bmiHeader.biClrUsed = 0;
	bmpInfo.bmiHeader.biClrImportant = 0;

	if ((count=fwrite(&bmpHeader, 1, sizeof(BITMAPFILEHEADER), fp)) != sizeof(BITMAPFILEHEADER))
		printf( "ERR004 д BMP ļͷʧ: count=%d\n", count);
	 

	if ((count=fwrite(&(bmpInfo.bmiHeader), 1, sizeof(BITMAPINFOHEADER), fp)) != sizeof(BITMAPINFOHEADER))
		printf( "ERR005 ȡBMP Ϣʧ: count=%d\n", count);
	 

	if ((count=fwrite(pRGBBuf, 1, RGB_SIZE, fp)) != RGB_SIZE)
		printf( "ERR006 д BMP ļʧ: count=%d\n", count);
 

	

	fclose(fp);
	return TRUE;
}

void Help()
{
	printf("ʹ˵: YUV2BMP /h352 /v240 <Yuvļ> <BMPļ> \n");
	printf("       /h352  - ָ߶ \n");
	printf("       /v240  -  ָ \n");
	printf("Copyright(c) MysticBoy 2007\n");

}

 
BOOL GetArgs(int argc, char* argv[])
{
	int i=0;
	char str255[256];

	if (argc != 5) 
	{
		Help();
		return FALSE;
	}


#define ArgIs(s)  (!strcmp(argv[i]+1, s))
	while(*(argv[++i]) == '/') // get parameters - must start with '/'
	{
 
		if ( (*(argv[i]+1) == 'h') || (*(argv[i]+1) == 'H'))
		{	
			strcpy(str255, argv[i]+2);
			IMAGE_WIDTH = atoi(str255);
		}
		else
		if ((*(argv[i]+1) == 'v') || (*(argv[i]+1) == 'V'))
		{	
			strcpy(str255, argv[i]+2);
			IMAGE_HEIGHT = atoi(str255);
		}
		
	}
 
	YUV_SIZE = IMAGE_WIDTH*IMAGE_HEIGHT + IMAGE_WIDTH*IMAGE_HEIGHT/2;
	RGB_SIZE = IMAGE_WIDTH*IMAGE_HEIGHT*3L;

	strcpy(YUVFilename, argv[3]); // next argument is a input file name
	strcpy(BMPFilename, argv[4]); // next argument is a output file name
	return TRUE;
}


int main(int argc, char* argv[])
{
	//char cWait;

	if (!GetArgs(argc, argv))
		return 0;

	pYUVBuf = pRGBBuf = NULL;
	MakeConversionTable();
	if (!AllocateBuffers())
	{
		printf( "ERR007 ڴʧ!\n");
	}
	else
	{
	 
		if (ReadYUVFile())
		{
			if (!YUV420ToRGB(IMAGE_WIDTH, IMAGE_HEIGHT, pYUVBuf, pRGBBuf))
				printf("ERR008 YCbCr4:2:0 ת BMP ʧ\n");
			else
			{
				if (WriteBMPFile())
					printf("OK YCbCr4:2:0 ɹתΪ BMP \n");
			}
		}
	}

	FreeBuffers();
 
	return 0;
}


